#pragma once

#ifndef _EES_COMMON_DEFINE_H_
#define _EES_COMMON_DEFINE_H_

#ifdef _EES_TRADE_API_SOFT_STRUCT_DEFINE_H_
namespace TraderSoft
{
#endif

typedef int RESULT;										///< 巵ֵ 
typedef int ERR_NO;										///< ֵ 


#ifdef WIN32
#define MY_SOCKET							SOCKET				//windows׼

#else	
#define MY_SOCKET							int	

#endif

typedef unsigned int			EES_ClientToken;					///< API˶ĿͻID
typedef int						EES_UserID;						///< ʻID
typedef long long int			EES_MarketToken;					///< г ID
typedef unsigned int			EES_Internal_Id;
typedef int						EES_TradingDate;					///< 
typedef unsigned long long int	EES_Nanosecond;					///< 1970110ʱ00뿪ʼʱ䣬ʹConvertFromTimestampӿתΪɶʱ

typedef char    EES_Account[17];						///< ʻ
typedef char    EES_DATE[9];							///< 
typedef char    EES_RULE_NAME[11];						///< ʻ
typedef char    EES_ProductID[32];						///< ڻĲƷ

typedef char    EES_ReasonText[88];						///< 
typedef char	EES_ReasonText2[81];					///< ͽгܾṹ
typedef char	EES_GrammerResultText[1024];			///< ﷨
typedef	char	EES_RiskResultText[1024];				///< ؼ

typedef char    EES_GrammerResult[32];					///< µ﷨
typedef char    EES_RiskResult[96];						///< µؼ

typedef char    EES_Symbol[20];							///< ׺Լ
typedef char    EES_Combo_Symbol[80];					///< ϺԼ
typedef char    EES_SymbolName[21];						///< ׺Լ
typedef char    EES_QUOTE_ID[24];						///< ۵


typedef char    EES_MarketOrderId[25];                  ///< 
typedef char	EES_MarketExecId[25];					///< ɽ
typedef char	EES_TIME[9];							///< صʱ
typedef unsigned char EES_MarketSessionId;				///< ϯλ

typedef unsigned char EES_SideType;						///< 
#define EES_SideType_open_long                  1		///< =򵥣
#define EES_SideType_close_today_long           2		///< =ƽ
#define EES_SideType_close_today_short          3		///< =򵥣ƽ
#define EES_SideType_open_short                 4		///< =
#define EES_SideType_close_ovn_short            5		///< =򵥣ƽ
#define EES_SideType_close_ovn_long             6		///< =ƽ
#define EES_SideType_today_opt_exec				11		///< =Ȩƽ
#define EES_SideType_ovn_opt_exec				12		///< =Ȩƽ
#define EES_SideType_opt_exec					13		///Ȩƽ֣
#define EES_SideType_abandon_today_opt_exec		14		///< =Ȩ
#define EES_SideType_abandon_ovn_opt_exec		15		///< =Ȩ
#define EES_SideType_abandon_opt_exec	  		16		///Ȩƽ֣
#define EES_sideType_opt_offset					17		///ȨԶԳ
#define EES_sideType_perform_offset				18		///ԼԳ
#define EES_SideType_close_short				21		///< =򵥣ƽ֣
#define EES_SideType_close_long					22		///< =ƽ֣


typedef unsigned char EES_ExchangeID;					///< ID
#define EES_ExchangeID_sh_cs                    100		///< =Ͻ
#define EES_ExchangeID_sz_cs                    101		///< =
#define EES_ExchangeID_cffex                    102		///< =н
#define EES_ExchangeID_shfe                     103		///< =
#define EES_ExchangeID_dce                      104		///< =
#define EES_ExchangeID_zcze                     105		///< =֣
#define EES_ExchangeID_ine						106		///< =Դ
#define EES_ExchangeID_sge						107		///< =Ϻ
#define EES_ExchangeID_gfex						108		///< = 
#define EES_ExchangeID_done_away                255		///< =Done-away 


typedef unsigned char EES_SecType;						///< Ʒ 
#define EES_SecType_cs                          1		///< =Ʊ
#define EES_SecType_options                     2		///< =Ȩ
#define EES_SecType_fut                         3		///< =ڻ


typedef unsigned char EES_ComboType;						///< Ʒ 
#define EES_ComboType_BullCallSpread                          1		///< =ţп
#define EES_ComboType_BearCallSpread						  2		///< =п
#define EES_ComboType_BullPutSpread						      3		///< =п
#define EES_ComboType_BearPutSpread						      4		///< =ţп
#define EES_ComboType_CalendarSpread					      5		///< =۲


typedef unsigned char EES_ForceCloseType;				///< ǿƽԭ 
#define EES_ForceCloseType_not_force_close      0		///< =ǿƽ  
#define EES_ForceCloseType_not_enough_bp        1		///< =ʽ  
#define EES_ForceCloseType_not_enough_position  2		///< =ͻ  
#define EES_ForceCloseType_not_enough_position2 3		///< =Ա  
#define EES_ForceCloseType_not_round_lot        4		///< =ֲַ  
#define EES_ForceCloseType_invalid              5		///< =Υ
#define EES_ForceCloseType_other                6		///< =

typedef unsigned char EES_OptExecFlag;
#define EES_OptExecFlag_normal					0		///< =Ȩ
#define EES_OptExecFlag_dont_auto_exec			1		///< =벻Զִ
#define EES_OptExecFlag_fut_hedge				2		///< =ڻλԶԳ

typedef unsigned char EES_ForceCloseReason;
#define EES_FORCE_CLOSE_REASON_NO_FORCE					0
#define EES_FORCE_CLOSE_REASON_LACK_OF_FUND				1
#define EES_FORCE_CLOSE_REASON_CLIENT_OVERFLOW_POS		2
#define EES_FORCE_CLOSE_REASON_MEMBER_OVERFLOW_POS		3
#define EES_FORCE_CLOSE_REASON_POS_ERROR				4
#define EES_FORCE_CLOSE_REASON_VIOLATION				5
#define EES_FORCE_CLOSE_REASON_OTHGER					6

typedef unsigned char EES_OrderState;					///< ״̬
#define EES_OrderState_order_accept               0		///< =ӽ
#define EES_OrderState_order_triggered            1		///< =Ӵ
#define EES_OrderState_order_suspened             2		///< =ӹ
#define EES_OrderState_order_activated            3		///< =Ӽ
#define EES_OrderState_order_cxled			      4		///< =ӳ
#define EES_OrderState_order_part_fill			  5		///< =ֳɽ
#define EES_OrderState_order_full_fill			  6		///< =ȫɽ


typedef int           EES_Previlege;					///< ĿǰӲݲ֧֣Ҳ˵ȫȨ 99ȫ  1ֻ 2ֻƽ
#define EES_Previlege_open_and_close            99		///< =Ȩ
#define EES_Previlege_readonly                  1		///< =ֻ
#define EES_Previlege_close_only                2		///< =ֻƽ


typedef int     EES_PosiDirection;						///< շ 1ͷ 5ͷ
#define EES_PosiDirection_long					1		///< =ͷ
#define EES_PosiDirection_short					5		///< =ͷ


typedef unsigned char EES_RejectedMan;					///< ˭ܾʢϵͳĽ 1=ʢ
#define EES_RejectedMan_by_shengli				1		///< =ʢܾ

typedef unsigned char EES_ReasonCode;					///< ӱܾɡűӡ±

typedef unsigned char EES_CxlReasonCode;				///< ɹԭ
#define EES_CxlReasonCode_by_account			1		///< =û
#define EES_CxlReasonCode_timeout				2		///< =ϵͳtimeout, ӵڱϵͳȡ
#define EES_CxlReasonCode_supervisory			3		///< =Supervisory, ʢϵͳȡ
#define EES_CxlReasonCode_by_market				4		///< =гܾ
#define EES_CxlReasonCode_another				255		///< =

typedef unsigned char EES_OrderStatus;					///< նŶ״̬
#define EES_OrderStatus_shengli_accept			0x80	///< bit7=1EESϵͳѽ
#define EES_OrderStatus_mkt_accept				0x40	///< bit6=1гѽֹܻԤ
#define EES_OrderStatus_executed				0x20	///< bit5=1ѳɽ򲿷ֳɽ
#define EES_OrderStatus_cancelled				0x10 	///< bit4=1ѳ, ǲֳɽ
#define EES_OrderStatus_cxl_requested			0x08	///< bit3=1ͻ
#define EES_OrderStatus_reserved1				0x04	///< bit2־λ
#define EES_OrderStatus_reserved2				0x02	///< bit1ֹӯֹ־λ
#define EES_OrderStatus_closed					0x01	///< bit0=1ѹر, (ܾ/ȫɽ/ѳ)

typedef unsigned int EES_OrderIOC;	
#define EES_OrderTif_Day						0	    ///< ڱ
#define EES_OrderTif_IOC						1		///< ҪFAK/FOKʱҪIOCΪ1
#define EES_OrderTif_GIS						2		///< GIS

typedef unsigned int EES_CustomFieldType;						///< Զֶ

typedef unsigned char EES_HedgeFlag;					///< Ͷ־
typedef unsigned char EES_ACCOUNT_INDEX;				///<˻
typedef unsigned short EES_SYMBOL_INDEX;				///<Լ

#define EES_HedgeFlag_Arbitrage				1			///< 
#define EES_HedgeFlag_Speculation			2			///< Ͷ
#define EES_HedgeFlag_Hedge					3			///< ױ

typedef int EES_LogonResult;
#define EES_LOGON_OK							0		///< ɹ
#define EES_LOGON_AUTHENTICATION_FAILED			1		///< û/벻
#define EES_LOGON_ACCOUNT_NOT_BOUND				2		///< ûδκʽ˻
#define EES_LOGON_ALREADY_LOGON					3		///< ϵͳΪظ¼ʱû¼ôͻֵ᷵Ŀǰһ㲻ôãӦòյ
#define EES_LOGON_ANOTHER_LOGON					4		///< Ѿ¼ɹٴε¼
#define EES_LOGON_MISSING_EXTRA_INFO			5		///< ȱٿͻ˱ʶmacַ
#define EES_LOGON_INTERNAL_ERROR				6		///< ϵͳڲ
#define EES_LOGON_NOT_USING_QUERY_PORT			7		///< ʹ°汾APIٻᷢ
#define EES_LOGON_CONNECT_QUERY_PORT_FAILED		8		///< Ӳѯͨʧ
#define EES_LOGON_RPTR_INVALID_INFO				11		///< ЧɼϢ
#define EES_LOGON_RPTR_IP_ERROR					12		///< ɼϱͽ׶˵ԶIPͬ
#define EES_LOGON_RPTR_APPID_AUTH_CODE_ERROR	13		///< УAPPIDȨ
#define EES_LOGON_CHECK_VERSION_FAILED			14		///< 汾Ųһ
#define EES_LOGON_SEND_TRADE_LOGON_FAILED		15		///< ͽ׵¼ʧ
#define EES_LOGON_SYSTEM_ENV_CRITICAL			99		///< Ŀǰӣڴ桢Ӳ̵ȿռ䲻㣬е¼ֹ


#define EES_RPTR_APPID_OR_AUTHCODE_ERROR            102     ///< ϱϢappidauthcode
#define EES_RPTR_LOGINID_OR_PASSWORD_ERROR			103		///< ϱϢû
#define EES_RPTR_VERSION_NOT_MATCH_ERROR			104     ///< ϱϢ汾ƥ
#define EES_RPTR_CHECK_ERROR						105		///< 汾
#define EES_RPTR_NET_ERROR							106     ///< 
#define EES_RPTR_ADDR_ERROR							107		///< ַ
#define EES_RPTR_DLL_ERROR							108		///< ̬
#define EES_RPTR_LOCAL_COLLECTION_ERROR				109		///< زɼϱϢ
#define EES_RPTR_REPORT_RSP_TIMEOUT					110		///< ϱϢӦķسʱ

typedef int EES_ChangePasswordResult;
#define EES_ChangePasswordResult_Success		0		///< ɹ
#define EES_ChangePasswordResult_OldPwdNotMatch	1		///< 벻
#define EES_ChangePasswordResult_NewPwdInvalid	2		///< Ƿհ׵
#define	EES_ChangePasswordResult_NotLogIn		3		///< δ¼
#define	EES_ChangePasswordResult_InternalError	99		///< ϵͳ̨

typedef unsigned char EES_OrderPriceType;
#define EES_Order_Type_Limt						1		///< ޼
#define EES_Order_Type_Market					2		///< мۣδ֧
#define EES_Order_Type_Stop_Profit_Limit		3		///< ޼ֹӯ
#define EES_Order_Type_Stop_Loss_Limit			4		///< ޼ֹ
#define EES_Order_Type_Stop_Profit_Market		5		///< мֹӯδ֧
#define EES_Order_Type_Stop_Loss_Market			6		///< мֹδ֧

typedef unsigned char EES_OrderExchangeStatus;
#define EES_Order_Exchange_Status_Accept			0		///< г
#define EES_Order_Exchange_Status_Triggered			1		///< ֹӯֹ𵥴
#define EES_Order_Exchange_Status_Suspended			2		///< 
#define EES_Order_Exchange_Status_Activated			3		///< 

#ifdef _EES_TRADE_API_SOFT_STRUCT_DEFINE_H_
}
#endif

#endif